diff --git a/src/lib/in.c b/src/lib/in.c
index bc05561fd..bb34e7c11 100644
--- a/src/lib/in.c
+++ b/src/lib/in.c
@@ -1567,14 +1567,14 @@ tcap_cb(inputctx* ictx){
   while(*s && (s = gettcap(s, &val, &key)) ){
     if(strcmp(val, "TN") == 0){
       if(ictx->initdata->qterm == TERMINAL_UNKNOWN){
-        if(strcasecmp(key, "xterm") == 0){
-          ictx->initdata->qterm = TERMINAL_XTERM; // "xterm"
-        }else if(strcasecmp(key, "mlterm") == 0){
+        if(strcmp(key, "xterm") == 0){
+          ictx->initdata->qterm = TERMINAL_XTERM;
+        }else if(strcmp(key, "mlterm") == 0){
           ictx->initdata->qterm = TERMINAL_MLTERM;
-        }else if(strcasecmp(key, "xterm-kitty") == 0){
-          ictx->initdata->qterm = TERMINAL_KITTY; // "xterm-kitty"
-        }else if(strcasecmp(key, "xterm-256color") == 0){
-          ictx->initdata->qterm = TERMINAL_XTERM; // "xterm-256color"
+        }else if(strcmp(key, "xterm-kitty") == 0){
+          ictx->initdata->qterm = TERMINAL_KITTY;
+        }else if(strcmp(key, "xterm-256color") == 0){
+          ictx->initdata->qterm = TERMINAL_XTERM;
         }else{
           logdebug("unknown terminal name %s", key);
         }
diff --git a/src/lib/termdesc.c b/src/lib/termdesc.c
index a8e03321b..fdc2e9fed 100644
--- a/src/lib/termdesc.c
+++ b/src/lib/termdesc.c
@@ -1067,7 +1067,6 @@ do_terminfo_lookups(tinfo *ti, size_t* tablelen, size_t* tableused){
     const char* tinfo;
   } strtdescs[] = {
     { ESCAPE_CUP, "cup", },
-    { ESCAPE_HPA, "hpa", },
     { ESCAPE_VPA, "vpa", },
     // Not all terminals support setting the fore/background independently
     { ESCAPE_SETAF, "setaf", },
@@ -1307,10 +1306,18 @@ int interrogate_terminfo(tinfo* ti, FILE* out, unsigned utf8,
     }
     if(iresp->appsync_supported){
       if(add_appsync_escapes_sm(ti, &tablelen, &tableused)){
+        free(iresp->hpa);
         free(iresp);
         goto err;
       }
     }
+    if(iresp->hpa){
+      if(grow_esc_table(ti, iresp->hpa, ESCAPE_HPA, &tablelen, &tableused)){
+        free(iresp->hpa);
+        goto err;
+      }
+      free(iresp->hpa);
+    }
     if((ti->kbdlevel = iresp->kbdlevel) == UINT_MAX){
       ti->kbdlevel = 0;
       if(!draininput){
@@ -1382,6 +1389,12 @@ int interrogate_terminfo(tinfo* ti, FILE* out, unsigned utf8,
   }else{
     ti->kbdlevel = 0; // confirmed no support, don't bother popping
   }
+  // now look up any terminfo elements we might not have received via requests
+  if(ti->escindices[ESCAPE_HPA] == 0){
+    if(init_terminfo_esc(ti, "hpa", ESCAPE_HPA, &tablelen, &tableused)){
+      goto err;
+    }
+  }
   if(*cursor_x >= 0 && *cursor_y >= 0){
     if(add_u7_escape(ti, &tablelen, &tableused)){
       goto err;
